#ifndef LPC_BITFIELDS_H_
#define LPC_BITFIELDS_H_


/* Вычисление позиции по битовой маске, т.е. младшего значащего бита в ненулевом числе
 * = pow(2, n), где n - количество нулевых младших разрядов */
#define BF_LSB(mask)                ((uint32_t)((mask) & ~((mask) - 1)))

/* Заполнение поля по битовой маске */
#define BF_SET(mask, val)           ((mask) & ((val) * BF_LSB(mask)))
/* Извлечение значения поля по битовой маске */
#define BF_GET(word, mask)          (((word) / BF_LSB(mask)) & ((mask) / BF_LSB(mask)))

#endif
