#ifndef __CHIP_H_
#define __CHIP_H_

#include <stdint.h>



#ifndef __IO
    #define __IO  volatile
#endif

#ifndef __I
    #define __I const volatile
#endif

#ifndef __O
    #define __O volatile
#endif

#include "bitfields.h"

#if defined(CHIP_LPC18XX)
    #define CHIP_SUPPORT_CMSIS
    #include "lpc18xx/chip.h"
#elif defined(CHIP_LPC43XX)
    #define CHIP_SUPPORT_CMSIS
    #include "lpc43xx/chip.h"
#elif defined(CHIP_LPC11U6X)
    #define CHIP_SUPPORT_CMSIS
    #include "lpc11u6x/chip.h"
#elif defined(CHIP_BF609)
    #include "bf609/chip.h"
#else
    #error no CHIP_XXX macro specified
#endif

#ifdef CHIP_SUPPORT_CMSIS
    #include "cmsis.h"
#endif


#endif /* __CHIP_H_ */
