/*
 * @brief LPC18xx/43xx GPIO driver
 *
 * @note
 * Copyright(C) NXP Semiconductors, 2013
 * All rights reserved.
 *
 * @par
 * Software that is described herein is for illustrative purposes only
 * which provides customers with programming information regarding the
 * LPC products.  This software is supplied "AS IS" without any warranties of
 * any kind, and NXP Semiconductors and its licensor disclaim any and
 * all warranties, express or implied, including all implied warranties of
 * merchantability, fitness for a particular purpose and non-infringement of
 * intellectual property rights.  NXP Semiconductors assumes no responsibility
 * or liability for the use of the software, conveys no license or rights under any
 * patent, copyright, mask work right, or any other intellectual property rights in
 * or to any products. NXP Semiconductors reserves the right to make changes
 * in the software without notification. NXP Semiconductors also makes no
 * representation or warranty that such application will be suitable for the
 * specified use without further testing or modification.
 *
 * @par
 * Permission to use, copy, modify, and distribute this software and its
 * documentation is hereby granted, under NXP Semiconductors' and its
 * licensor's relevant copyrights in the software, without fee, provided that it
 * is used in conjunction with NXP Semiconductors microcontrollers.  This
 * copyright, permission, and disclaimer notice must appear in all copies of
 * this code.
 */

#ifndef __GPIO_18XX_43XX_H_
#define __GPIO_18XX_43XX_H_

/**
 * @brief  GPIO port register block structure
 */
typedef struct {                /*!< GPIO_PORT Structure */
    __IO uint8_t B[128][32];    /*!< Offset 0x0000: Byte pin registers ports 0 to n; pins PIOn_0 to PIOn_31 */
    __IO uint32_t W[32][32];    /*!< Offset 0x1000: Word pin registers port 0 to n */
    __IO uint32_t DIR[32];      /*!< Offset 0x2000: Direction registers port n */
    __IO uint32_t MASK[32];     /*!< Offset 0x2080: Mask register port n */
    __IO uint32_t PIN[32];      /*!< Offset 0x2100: Portpin register port n */
    __IO uint32_t MPIN[32];     /*!< Offset 0x2180: Masked port register port n */
    __IO uint32_t SET[32];      /*!< Offset 0x2200: Write: Set register for port n Read: output bits for port n */
    __O  uint32_t CLR[32];      /*!< Offset 0x2280: Clear port n */
    __O  uint32_t NOT[32];      /*!< Offset 0x2300: Toggle port n */
} LPC_GPIO_T;

#endif /* __GPIO_18XX_43XX_H_ */
