/*
 * lip_arp.h
 *
 *  Created on: 30.07.2010
 *      Author: borisov
 */

#ifndef __LIP_ARP_H__
#define __LIP_ARP_H__

#include "lip_conf.h"
#include "lip_defs.h"

#include "net/lip_ip.h"

//hardware address space types
#define LIP_HRD_ETHERNET  1


#define ARP_PROBE(__addr)  lip_arp_send_req(LIP_IPTYPE_IPv4, 0, __addr, LIP_IPV4_ADDR_SIZE)
#define ARP_ANNOUNCE(__addr)  lip_arp_send_req(LIP_IPTYPE_IPv4, __addr, __addr, LIP_IPV4_ADDR_SIZE)

void lip_arp_init(void);
void lip_arp_pull(void);
t_lip_errs lip_arp_process_packet(uint8_t *data, size_t len, int ll_flags);
uint8_t* lip_arp_resolve(t_lip_ip_type type, const uint8_t *ip_addr);
void lip_arp_invalidate(t_lip_ip_type type, const uint8_t *ip_addr);

//void lip_arp_add_ip(const uint8_t* ip_addr, const uint8_t* hrd_addr);
uint8_t lip_arp_upd_ip(const uint8_t* ip_addr, const uint8_t* hrd_addr);
int lip_arp_send_req(t_lip_ip_type type, const uint8_t* local_ip, const uint8_t* ip, uint8_t len);





#endif /* LIP_ARP_H_ */
