#ifndef LIP_CORE_PRIV_H
#define LIP_CORE_PRIV_H

#include "lip.h"


typedef struct {
    uint8_t *addr; //текущий адрес - указывает на routable_addr или ll_addr
    uint8_t routable_addr[LIP_IPV4_ADDR_SIZE]; //статический адрес или полученный через DHCP
    uint8_t previous_addr[LIP_IPV4_ADDR_SIZE]; //предыдущий адрес (чтобы при повторном коннекте сравнить)
    uint8_t mask[LIP_IPV4_ADDR_SIZE]; //маска сети
    uint8_t gate[LIP_IPV4_ADDR_SIZE]; //адрес шлюза по-умолчанию
#ifdef LIP_USE_LINK_LOCAL_ADDR
    uint8_t ll_addr[LIP_IPV4_ADDR_SIZE]; //link-local адрес
    uint8_t ll_en; //разрешение получения link-local адреса
#endif
    uint16_t id;
} t_lip_ip_state;


typedef struct {
    t_lip_ip_state ip;
} t_lip;


extern t_lip g_lip_st;


/* признак, что изменился предпочитаемый по данному интерфейсу
    адрес (например link-local на routable) */
#define LIP_ADDRCH_FLAGS_CH_PREF  0x1

void lip_ip_addr_changed(t_lip_ip_type type, const uint8_t* addr_ptr,
                         const uint8_t* old_addr, int flags, int len);

#endif // LIP_CORE_PRIV_H
