/*
 * lip_ipv4_acd.h
 *
 *  Created on: 25.07.2011
 *      Author: Borisov
 */

#ifndef LIP_IPV4_ACD_H_
#define LIP_IPV4_ACD_H_

#include "lip_defs.h"


/* dhcp и link-local используют модуль acd для проверки адресов
 *  => при использовании этих протоколов ACD должен быть всегда включен
 */
#if defined LIP_USE_DHCPC || defined LIP_USE_LINK_LOCAL_ADDR
    #ifndef LIP_USE_IPV4_ACD
        #define LIP_USE_IPV4_ACD
    #endif
#endif

/* коды событий, передаваемых в callback-е */
#define LIP_IPV4_ACD_EVENT_ADDR_ESTABLISHED   1
#define LIP_IPV4_ACD_EVENT_ADDR_CONFLICT      2
/* callback функция, вызываемая при возникновении события, связанного с адресом */
typedef void (*t_lip_ipv4_acd_cb)(const uint8_t* addr, int event);



/* запуск процедуры проверки ip-адреса */
int lip_ipv4_acd_probe(const uint8_t* addr, t_lip_ipv4_acd_cb cb, uint32_t init_tout);
/* освобождение отслеживания ip-адреса */
int lip_ipv4_acd_leave(const uint8_t* addr);
/* инициализация модуля  */
void lip_ipv4_acd_init(void);
/* продвижение модуля - фоновые задачи */
int lip_ipv4_acd_pull(void);
/* arp-callback на прием пакета */
void lip_ipv4_acd_arp_cb(const uint8_t *src_addr, const uint8_t *dst_addr,
        const uint8_t* src_mac);


#endif /* LIP_IPV4_ACD_H_ */
