#ifndef LAN8720_REGS_H_
#define LAN8720_REGS_H_

#define LAN8720_REG_SILICON_REV 0x10
#define LAN8720_REG_MODECS      0x11 /* Mode Control/Status */
#define LAN8720_REG_SPECMODES   0x12 /* Special Mode */
#define LAN8720_REG_SYMERRCNT   0x1A /* Symbol Error Counter  */
#define LAN8720_REG_CSIND       0x1B /* Control / Status Indication */
#define LAN8720_REG_TEST_CTL    0x1C /* Special internal testability controls */
#define LAN8720_REG_INTSRC      0x1D /* Interrupt source */
#define LAN8720_REG_INTMSK      0x1E /* Interrupt mask */
#define LAN8720_REG_PHYSCSR     0x1F /* PHY Special Control/Status */


/* PHY Special Control/Status */
#define LAN8720_BIT_PHYSCSR_SCRAM_DIS     (0x01UL << 0)
#define LAN8720_BIT_PHYSCSR_SPEED_IND     (0x07UL << 2)
#define LAN8720_BIT_PHYSCSR_4B5B_EN       (0x01UL << 6)
#define LAN8720_BIT_PHYSCSR_GPIO          (0x07UL << 9)
#define LAN8720_BIT_PHYSCSR_AUTODONE      (0x01UL << 12)



#endif //LAN8720_REGS_H_
